<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: Matop.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Matop.c File Reference</h1><code>#include &lt;stdlib.h&gt;</code><br/>
<code>#include &lt;<a class="el" href="polylib_8h_source.html">polylib/polylib.h</a>&gt;</code><br/>

<p><a href="Matop_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a69ef60460903eaa2378b40e13181e565">Lcm3</a> (Value a, Value b, Value *c)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">Value *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a13dc27a49cfaf5367846f015b76c2840">Lcm</a> (Value i, Value j)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#ac886b07103118bccddf1693e2bb9655f">Identity</a> (unsigned <a class="el" href="vector_8c.html#a439227feff9d7f55384e8780cfc2eb82">size</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#acf8ce28d22ae1fabdf97ac6c4e86341a">ExchangeRows</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, int Row1, int Row2)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#af9321ba930c53a16bb88667689268d5d">ExchangeColumns</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, int Column1, int Column2)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#ab635a9108899776e30e1de03fe183915">Transpose</a> (<a class="el" href="structmatrix.html">Matrix</a> *A)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a9d027e9fc6b85e6fa37fc284bf1b5e06">Matrix_Copy</a> (<a class="el" href="structmatrix.html">Matrix</a> const *Src)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#ab11e2b3f499da1c15918d52e690cfbd1">isIntegral</a> (<a class="el" href="structmatrix.html">Matrix</a> *A)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a3f47c6fa59a6178c86d3990bb25af47b">isinHnf</a> (<a class="el" href="structmatrix.html">Matrix</a> *A)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a437f63cf9b5f8caea2b5dd4b27f9a28a">PutRowLast</a> (<a class="el" href="structmatrix.html">Matrix</a> *X, int Rownumber)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#ab6ddbe687809022ebaf4ff691adbb48d">PutRowFirst</a> (<a class="el" href="structmatrix.html">Matrix</a> *X, int Rownumber)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#abff6804a65715b1def03cf02c07d138c">PutColumnFirst</a> (<a class="el" href="structmatrix.html">Matrix</a> *X, int Columnnumber)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a5912c5c3befc11a92877a93969f359f6">PutColumnLast</a> (<a class="el" href="structmatrix.html">Matrix</a> *X, int Columnnumber)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a76461087aa1a40441a3dc174e8359b97">AddANullRow</a> (<a class="el" href="structmatrix.html">Matrix</a> *M)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a7d43e9c44b8c49cd9a542102042ad72e">AddANullColumn</a> (<a class="el" href="structmatrix.html">Matrix</a> *M)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a4ef5342bc70d9c63714d1092a7668b03">RemoveRow</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, int Rownumber)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a4b8fff8126ca3b066999fd338c0ba023">RemoveNColumns</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, int FirstColumnnumber, int NumColumns)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#a7866f34e302caaf90becd08b1245c126">RemoveColumn</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, int Columnnumber)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="Matop_8c.html#ad77e679cec7ff5e82f9d09d52e92db06">findHermiteBasis</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, <a class="el" href="structmatrix.html">Matrix</a> **Result)</td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a7d43e9c44b8c49cd9a542102042ad72e"></a><!-- doxytag: member="Matop.c::AddANullColumn" ref="a7d43e9c44b8c49cd9a542102042ad72e" args="(Matrix *M)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* AddANullColumn </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00286">286</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>, <a class="el" href="homogenization_8c_source.html#l00031">homogenize()</a>, and <a class="el" href="testehrhart_8c_source.html#l00130">main()</a>.</p>

</div>
</div>
<a class="anchor" id="a76461087aa1a40441a3dc174e8359b97"></a><!-- doxytag: member="Matop.c::AddANullRow" ref="a76461087aa1a40441a3dc174e8359b97" args="(Matrix *M)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* AddANullRow </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00268">268</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>, and <a class="el" href="SolveDio_8c_source.html#l00248">RearrangeMatforSolveDio()</a>.</p>

</div>
</div>
<a class="anchor" id="af9321ba930c53a16bb88667689268d5d"></a><!-- doxytag: member="Matop.c::ExchangeColumns" ref="af9321ba930c53a16bb88667689268d5d" args="(Matrix *M, int Column1, int Column2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ExchangeColumns </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Column1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Column2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00090">90</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00465">value_swap</a>.</p>

</div>
</div>
<a class="anchor" id="acf8ce28d22ae1fabdf97ac6c4e86341a"></a><!-- doxytag: member="Matop.c::ExchangeRows" ref="acf8ce28d22ae1fabdf97ac6c4e86341a" args="(Matrix *M, int Row1, int Row2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ExchangeRows </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Row1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Row2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00072">72</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="polyhedron_8c_source.html#l01906">Constraints2Polyhedron()</a>, and <a class="el" href="SolveDio_8c_source.html#l00248">RearrangeMatforSolveDio()</a>.</p>

</div>
</div>
<a class="anchor" id="ad77e679cec7ff5e82f9d09d52e92db06"></a><!-- doxytag: member="Matop.c::findHermiteBasis" ref="ad77e679cec7ff5e82f9d09d52e92db06" args="(Matrix *M, Matrix **Result)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int findHermiteBasis </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>Result</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00361">361</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="Matop_8c_source.html#l00286">AddANullColumn()</a>, <a class="el" href="Matop_8c_source.html#l00268">AddANullRow()</a>, <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>, <a class="el" href="Matop_8c_source.html#l00058">Identity()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="Matop_8c_source.html#l00118">Matrix_Copy()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="Matop_8c_source.html#l00303">RemoveRow()</a>, <a class="el" href="SolveDio_8c_source.html#l00081">SolveDiophantine()</a>, <a class="el" href="Matop_8c_source.html#l00103">Transpose()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>, and <a class="el" href="vector_8c_source.html#l00179">Vector_Free()</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00990">FindHermiteBasisofDomain()</a>.</p>

</div>
</div>
<a class="anchor" id="ac886b07103118bccddf1693e2bb9655f"></a><!-- doxytag: member="Matop.c::Identity" ref="ac886b07103118bccddf1693e2bb9655f" args="(unsigned size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* Identity </td>
          <td>(</td>
          <td class="paramtype">unsigned&nbsp;</td>
          <td class="paramname"> <em>size</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00058">58</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="Zpolyhedron_8c_source.html#l00761">CanonicalForm()</a>, <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>, <a class="el" href="Lattice_8c_source.html#l00990">FindHermiteBasisofDomain()</a>, <a class="el" href="Zpolyhedron_8c_source.html#l00854">IntegraliseLattice()</a>, and <a class="el" href="NormalForms_8c_source.html#l00627">Smith()</a>.</p>

</div>
</div>
<a class="anchor" id="a3f47c6fa59a6178c86d3990bb25af47b"></a><!-- doxytag: member="Matop.c::isinHnf" ref="a3f47c6fa59a6178c86d3990bb25af47b" args="(Matrix *A)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a> isinHnf </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00157">157</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00234">False</a>, <a class="el" href="Lattice_8c_source.html#l00312">Homogenise()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="types_8h_source.html#l00234">True</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00480">value_ge</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00814">LatticeDifference()</a>, <a class="el" href="Lattice_8c_source.html#l00475">LatticeIntersection()</a>, and <a class="el" href="Zpolyhedron_8c_source.html#l00971">SplitZpolyhedron()</a>.</p>

</div>
</div>
<a class="anchor" id="ab11e2b3f499da1c15918d52e690cfbd1"></a><!-- doxytag: member="Matop.c::isIntegral" ref="ab11e2b3f499da1c15918d52e690cfbd1" args="(Matrix *A)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a> isIntegral </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00134">134</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00234">False</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="types_8h_source.html#l00234">True</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00525">value_modulus</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>.</p>

</div>
</div>
<a class="anchor" id="a13dc27a49cfaf5367846f015b76c2840"></a><!-- doxytag: member="Matop.c::Lcm" ref="a13dc27a49cfaf5367846f015b76c2840" args="(Value i, Value j)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Value* Lcm </td>
          <td>(</td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>j</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00045">45</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="Matop_8c_source.html#l00022">Lcm3()</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

</div>
</div>
<a class="anchor" id="a69ef60460903eaa2378b40e13181e565"></a><!-- doxytag: member="Matop.c::Lcm3" ref="a69ef60460903eaa2378b40e13181e565" args="(Value a, Value b, Value *c)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Lcm3 </td>
          <td>(</td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>c</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00022">22</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="vector_8c_source.html#l00116">Gcd()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00529">value_absolute</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00523">value_division</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00519">value_multiply</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>.</p>

<p>Referenced by <a class="el" href="Matop_8c_source.html#l00045">Lcm()</a>.</p>

</div>
</div>
<a class="anchor" id="a9d027e9fc6b85e6fa37fc284bf1b5e06"></a><!-- doxytag: member="Matop.c::Matrix_Copy" ref="a9d027e9fc6b85e6fa37fc284bf1b5e06" args="(Matrix const *Src)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* Matrix_Copy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> const *&nbsp;</td>
          <td class="paramname"> <em>Src</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00118">118</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00928">AddLattice()</a>, <a class="el" href="Lattice_8c_source.html#l00176">AffineHermite()</a>, <a class="el" href="Lattice_8c_source.html#l00221">AffineSmith()</a>, <a class="el" href="Zpolyhedron_8c_source.html#l00761">CanonicalForm()</a>, <a class="el" href="ehrhart_8c_source.html#l02677">Constraints_EhrhartQuickApx()</a>, <a class="el" href="matrix__permutations_8c_source.html#l00134">eliminable_vars()</a>, <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>, <a class="el" href="Lattice_8c_source.html#l00990">FindHermiteBasisofDomain()</a>, <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>, <a class="el" href="Lattice_8c_source.html#l00312">Homogenise()</a>, <a class="el" href="Lattice_8c_source.html#l00674">Lattice2LatticeUnion()</a>, <a class="el" href="compress__parms_8c_source.html#l00499">Lattice_extractSubLattice()</a>, <a class="el" href="Lattice_8c_source.html#l00814">LatticeDifference()</a>, <a class="el" href="Lattice_8c_source.html#l01126">LatticeImage()</a>, <a class="el" href="Lattice_8c_source.html#l00475">LatticeIntersection()</a>, <a class="el" href="ranking_8c_source.html#l00051">LexSmaller()</a>, <a class="el" href="Zpolytest_8c_source.html#l00029">main()</a>, <a class="el" href="matrix__addon_8c_source.html#l00123">mtransformation_inverse()</a>, <a class="el" href="polyhedron_8c_source.html#l04089">Polyhedron_Image()</a>, <a class="el" href="ext__ehrhart_8c_source.html#l00835">Polyhedron_Image_Enumerate()</a>, <a class="el" href="SolveDio_8c_source.html#l00248">RearrangeMatforSolveDio()</a>, <a class="el" href="Lattice_8c_source.html#l01306">Simplify()</a>, <a class="el" href="NormalForms_8c_source.html#l00627">Smith()</a>, <a class="el" href="SolveDio_8c_source.html#l00081">SolveDiophantine()</a>, <a class="el" href="Zpolyhedron_8c_source.html#l00971">SplitZpolyhedron()</a>, <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>, <a class="el" href="testCompressParms_8c_source.html#l00071">test_Constraints_Remove_parm_eqs()</a>, <a class="el" href="testCompressParms_8c_source.html#l00139">test_Polyhedron_Remove_parm_eqs()</a>, <a class="el" href="Zpolyhedron_8c_source.html#l00887">ZDomainSimplify()</a>, and <a class="el" href="Zpolyhedron_8c_source.html#l00055">ZPolyhedron_Alloc()</a>.</p>

</div>
</div>
<a class="anchor" id="abff6804a65715b1def03cf02c07d138c"></a><!-- doxytag: member="Matop.c::PutColumnFirst" ref="abff6804a65715b1def03cf02c07d138c" args="(Matrix *X, int Columnnumber)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PutColumnFirst </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>X</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Columnnumber</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00230">230</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00312">Homogenise()</a>.</p>

</div>
</div>
<a class="anchor" id="a5912c5c3befc11a92877a93969f359f6"></a><!-- doxytag: member="Matop.c::PutColumnLast" ref="a5912c5c3befc11a92877a93969f359f6" args="(Matrix *X, int Columnnumber)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PutColumnLast </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>X</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Columnnumber</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00249">249</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00312">Homogenise()</a>.</p>

</div>
</div>
<a class="anchor" id="ab6ddbe687809022ebaf4ff691adbb48d"></a><!-- doxytag: member="Matop.c::PutRowFirst" ref="ab6ddbe687809022ebaf4ff691adbb48d" args="(Matrix *X, int Rownumber)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PutRowFirst </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>X</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Rownumber</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00210">210</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00312">Homogenise()</a>.</p>

</div>
</div>
<a class="anchor" id="a437f63cf9b5f8caea2b5dd4b27f9a28a"></a><!-- doxytag: member="Matop.c::PutRowLast" ref="a437f63cf9b5f8caea2b5dd4b27f9a28a" args="(Matrix *X, int Rownumber)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PutRowLast </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>X</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Rownumber</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00188">188</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00312">Homogenise()</a>.</p>

</div>
</div>
<a class="anchor" id="a7866f34e302caaf90becd08b1245c126"></a><!-- doxytag: member="Matop.c::RemoveColumn" ref="a7866f34e302caaf90becd08b1245c126" args="(Matrix *M, int Columnnumber)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* RemoveColumn </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Columnnumber</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00340">340</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="vector_8c_source.html#l00269">Vector_Copy()</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00990">FindHermiteBasisofDomain()</a>.</p>

</div>
</div>
<a class="anchor" id="a4b8fff8126ca3b066999fd338c0ba023"></a><!-- doxytag: member="Matop.c::RemoveNColumns" ref="a4b8fff8126ca3b066999fd338c0ba023" args="(Matrix *M, int FirstColumnnumber, int NumColumns)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* RemoveNColumns </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>FirstColumnnumber</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>NumColumns</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00322">322</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="vector_8c_source.html#l00269">Vector_Copy()</a>.</p>

</div>
</div>
<a class="anchor" id="a4ef5342bc70d9c63714d1092a7668b03"></a><!-- doxytag: member="Matop.c::RemoveRow" ref="a4ef5342bc70d9c63714d1092a7668b03" args="(Matrix *M, int Rownumber)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* RemoveRow </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>Rownumber</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00303">303</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="vector_8c_source.html#l00269">Vector_Copy()</a>.</p>

<p>Referenced by <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>.</p>

</div>
</div>
<a class="anchor" id="ab635a9108899776e30e1de03fe183915"></a><!-- doxytag: member="Matop.c::Transpose" ref="ab635a9108899776e30e1de03fe183915" args="(Matrix *A)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structmatrix.html">Matrix</a>* Transpose </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="Matop_8c_source.html#l00103">103</a> of file <a class="el" href="Matop_8c_source.html">Matop.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="NormalForms_8c_source.html#l00297">transpose()</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>.</p>

<p>Referenced by <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>, <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>, and <a class="el" href="ext__ehrhart_8c_source.html#l00835">Polyhedron_Image_Enumerate()</a>.</p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:27 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
